package org.gidea.scada.monitor.rabbit.template;

import org.gidea.scada.monitor.rabbit.entity.MonitorMessage;
import org.gidea.scada.monitor.rabbit.listener.MonitorRabbitListener;
import org.gidea.scada.monitor.utils.Constants;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

@Configuration
public class MonitorRabbitTemplate {

    @Resource
    private RabbitTemplate rabbitTemplate;

    @Resource
    private MonitorRabbitListener rabbitListener;


    /**
     * 发送消息
     *
     * @param deviceId
     * @param message
     */
    public void sendMessage(String deviceId, MonitorMessage message) {
        rabbitListener.addDeviceListener(deviceId);
        rabbitTemplate.convertAndSend(Constants.MonitorServiceName, message.toString());
    }

}
