package org.gidea.scada.monitor.rabbit.entity;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

@Data
@NoArgsConstructor
public class MonitorMessage {
    /**
     * 客户端ID
     */
    private String clientId;
    /**
     * 采集端ID
     */
    private String collectId;
    /**
     * 设备标识
     */
    private String deviceId;
    /**
     * 下发命令
     */
    private String command;
    /**
     * 下发命令时间
     */
    private LocalDateTime issueTime;
    /**
     * 命令响应结果
     */
    private String response;
    /**
     * 响应时间
     */
    private LocalDateTime responseTime;

    public MonitorMessage(String clientId, String collectId, String deviceId, String command) {
        this.clientId = clientId;
        this.collectId = collectId;
        this.deviceId = deviceId;
        this.command = command;
        this.issueTime = LocalDateTime.now();
    }

    public MonitorMessage(String clientId, String deviceId, String command) {
        this.clientId = clientId;
        this.deviceId = deviceId;
        this.command = command;
        this.issueTime = LocalDateTime.now();
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }
}
