package org.gidea.scada.monitor.rabbit.entity;

import lombok.Data;

@Data
public class Result<R> {

    private int code;

    private String message;

    private R data;

    public static <R> Result<R> success(R data) {
        Result<R> result = new Result<>();
        result.setCode(0);
        result.setMessage("success");
        result.setData(data);
        return result;
    }

    public static <R> Result<R> fail(String message) {
        Result<R> result = new Result<>();
        result.setCode(-1);
        result.setMessage(message);
        return result;
    }

    public boolean isSuccess() {
        return this.code == 0;
    }
}
