package org.gidea.scada.monitor.mqtt.handler;

import com.alibaba.fastjson.JSONObject;
import org.gidea.scada.monitor.rabbit.entity.MonitorMessage;
import org.gidea.scada.monitor.utils.MonitorUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.jms.*;
import java.time.LocalDateTime;

@Component
public class MqttHandler {
    @Resource(name = "mqttSession")
    private Session session;

    public void handler(String message) {
        MonitorMessage msg = JSONObject.parseObject(message, MonitorMessage.class);
        msg.setResponse("响应成功");
        msg.setResponseTime(LocalDateTime.now());
        // 创建目标
        Destination destination = null;
        try {
            destination = session.createTopic(MonitorUtils.getMqttQueueName(msg.getDeviceId()));
            // 创建生产者
            MessageProducer producer = session.createProducer(destination);
            producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
            // 创建消息
            BytesMessage textMessage = session.createBytesMessage();
            textMessage.writeBytes(msg.toString().getBytes());
            // 发送消息
            producer.send(textMessage);
        } catch (JMSException e) {
            throw new RuntimeException(e);
        }

    }
}
