package org.gidea.scada.monitor.rabbit.config;

import com.rabbitmq.client.Channel;
import lombok.SneakyThrows;
import org.gidea.scada.monitor.utils.Constants;
import org.springframework.amqp.core.Exchange;
import org.springframework.amqp.core.FanoutExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.rabbit.core.RabbitAdmin;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

@Configuration
public class MonitorRabbitMQConfig {
    @Resource
    Channel channel;

    @SneakyThrows
    @Bean
    public Exchange exchange(RabbitAdmin rabbitAdmin) {
        FanoutExchange serviceExchange = new FanoutExchange(Constants.MonitorServiceExchangeName, true, true);
        rabbitAdmin.declareExchange(serviceExchange);
        // 声明请求主队列
        Queue requestQueue = new Queue(Constants.MonitorServiceName, true, true, true);
        rabbitAdmin.declareQueue(requestQueue);
        channel.queueBind(Constants.MonitorServiceName, Constants.MonitorServiceExchangeName, Constants.MonitorServiceExchangeName);
        return serviceExchange;
    }

}
