package org.gidea.scada.monitor.rabbit.listener;

import com.rabbitmq.client.Channel;
import lombok.extern.log4j.Log4j2;
import org.gidea.scada.monitor.mqtt.handler.MqttHandler;
import org.gidea.scada.monitor.utils.Constants;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Log4j2
@Component
public class MonitorRabbitListener {
    @Resource
    private MqttHandler mqttHandler;
    @Resource
    private Channel channel;

    @RabbitListener(queues = Constants.MonitorServiceName)
    public void deviceTopic(String message) {
        log.info("接收消息：{}", message);
        mqttHandler.handler(message);
    }

}
