package org.gidea.scada.monitor.rabbit.service.impl;

import org.gidea.scada.monitor.rabbit.entity.Result;
import org.gidea.scada.monitor.rabbit.service.MonitorRabbitService;
import org.gidea.scada.monitor.utils.MonitorUtils;
import org.springframework.amqp.core.FanoutExchange;
import org.springframework.amqp.rabbit.core.RabbitAdmin;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class MonitorRabbitServiceImpl implements MonitorRabbitService {

    @Resource
    private RabbitAdmin rabbitAdmin;

    @Override
    public Result<String> applyConnection(String deviceId) {
        String exchangeName = MonitorUtils.getClientExchangeName(deviceId);
        FanoutExchange clientExchange = new FanoutExchange(exchangeName, false, false);
        rabbitAdmin.declareExchange(clientExchange);
        return Result.success(exchangeName);
    }

}
